Update an order
Notes:
- This operation is only available if you have the Orders feature enabled. If you are an existing Zuora Subscribe and Amend customer, we recommend you enable Orders Harmonization to access the Orders feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing.
- Update an order is only valid for draft or scheduled orders.
- This operation doesn’t support auto-refund and invoice write-off during subscription cancellation. Use the “Create an order” operation instead.
- You must provide full payload when using the “Update an order” operation. That is, if you want to edit one order action, you need to provide all other order actions in the payload. Otherwise, the other order actions will be removed.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Path parameters
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Request
Category of the order to indicate a product sale or return. Default value is NewSales.
The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.
Note You can specify either the existingAccountNumber or existingAccountId field, but not both.
The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.
The order number of the new order. If not provided, system will auto-generate a number for this order.
Note: The characters #, ?, and / are not allowed in this field.
The container for billing processing options and payment processing options.
Note:
- This field is not supported in draft orders.
- When you use the “Create an order” operation to create an account, create a subscription, run billing, and collect payment in a single call, if any error occurs during the call, such as a payment processing failure and a tax engine failure, then all the other steps will be rolled back. In this case, neither the invoice will be generated, nor the subscription nor the account will be created.
- When you use the “Create an order” operation to cancel a subscription with
refundandwriteOff, if therefundorwriteOfffails,cancelSubscription,runBilling, andcollectPaymentstill can succeed. - When you use the “Create an order” operation, the
collectPaymentandrefundfields cannot be set totruesimultaneously. Otherwise, the order will not be proceeded.
Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs.
The status of the order. The default value is Completed. The following values are supported:
Draft: The order is in draft status.Pending: The order is in pending status.Completed: The order is in completed status.Scheduled: The order is in scheduled status and it is only valid if the Scheduled Orders feature is enabled.Executing: The scheduled order is executed by a scheduler and it is only valid if the Scheduled Orders feature is enabled.Failed: The scheduled order has failed.
Note: If you have the Pending Subscription Processing feature turned on and want to update a completed order with an active subscription with pending charges, you must specify Completed in this field because the default order status is Pending for this scenario.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
The container of the error code and message. This field is available only if the success field is false.
The account ID for the order. This field is returned instead of the accountNumber field if the returnIds query parameter is set to true.
An array of the credit memo IDs generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled. This field is returned instead of the creditMemoNumbers field if the returnIds query parameter is set to true.
An array of the invoice IDs generated in this order request. Normally it includes one invoice ID only, but can include multiple items when a subscription was tagged as invoice separately. This field is returned instead of the invoiceNumbers field if the returnIds query parameter is set to true.
The ID of the order created. This field is returned instead of the orderNumber field if the returnIds query parameter is set to true.
The payment Id that is collected in this order request. This field is returned instead of the paymentNumber field if the returnIds query parameter is set to true.
Note: This field is only available if you have the Ramps feature enabled. The Orders feature must be enabled before you can access the Ramps feature. The Ramps feature is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see Zuora Editions for pricing information coming October 2020. The ramp definitions created by this order request.
Status of the order. Pending is only applicable for an order that contains a CreateSubscription order action.
Container for the subscription IDs of the subscriptions in an order. This field is returned if the returnIds query parameter is set to true.
This field is available only if you are on the latest Zuora API minor
version, or you set the Zuora-Version request header to 223.0 or a
later available version.